package com.punkcraft.zombiedrop;

import net.minecraft.entity.monster.EntityZombie;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.DamageSource;
import net.minecraft.world.World;
import net.minecraft.entity.item.EntityItem;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.relauncher.Side;

@Mod.EventBusSubscriber(value = Side.SERVER, modid = ZombieDrop.MODID)
public class ServerEventHandler {

    /**
     * Обработчик события дропа предметов.
     */
    @SubscribeEvent
    public static void onLivingDrops(LivingDropsEvent event) {
        // Проверяем, что убитая сущность - это зомби
        if (event.getEntityLiving() instanceof EntityZombie) {
            EntityZombie zombie = (EntityZombie) event.getEntityLiving();
            DamageSource source = event.getSource();

            // Проверяем, что зомби был убит игроком или мобом
            if (source.getTrueSource() != null || source.isExplosion()) {
                // Генерируем случайное число от 0 до 99
                int random = zombie.world.rand.nextInt(100);

                // Если число меньше 4, добавляем эндерпёрл в дроп
                if (random < 4) {
                    ItemStack enderPearl = new ItemStack(Item.getItemById(368), 1); // ID эндерпёрла: 368
                    World world = zombie.world;
                    double x = zombie.posX;
                    double y = zombie.posY;
                    double z = zombie.posZ;

                    // Создаем EntityItem и добавляем его в дроп
                    EntityItem entityItem = new EntityItem(world, x, y, z, enderPearl);
                    event.getDrops().add(entityItem);
                }
            }
        }
    }
}
